/* -*- mode: c++; indent-tabs-mode:nil -*- */
#include <string>
#include "jarray.h"
#include "trjfile.h"

using namespace std;

jarray loadtrj(jarray x, jarray y) {
  jengine *je=y.getEngine();
  string filename;
  y.get(filename);
  trjfile trj;
  trj.open(filename,false);
  assert(trj.good());
  int neq=trj.getNEQ();
  assert(neq>0);
  assert(trj.size()>=1);
  trj.toFrame(-1);
  jarray res;
  if (x.isValid()) {
    assert((x.rank()==0)||(x.rank()==1));
    jarray_of_type<jarray::I> shape(x);
    int n=1;
    for(int i=0;i<shape.size();i++) n*=shape[i];
    assert(n==neq);
    jarray_of_type<double> tres(je, x.size(),&shape[0]);
    res=tres;
  } else {
    jarray_of_type<double> tres(je, neq);
    res=tres;
  };
  double T; // time is ignored
  trj.loadFrame(T,(double*)res.data());
  trj.close();
  return res;
};

jarray loadtrj(jarray y) {
  jarray x; // invalid unallocated array
  return loadtrj(x,y);
};
